package brentmaas.CW4x3Challenge;
import java.awt.*;
import java.awt.event.*;

public class GUIGame extends GUI{
	public boolean hasAI;
	public AI ai;
	public boolean paused = false;
	public boolean spectatingTile = false;
	public boolean movingUnitsS1 = false;
	public boolean movingUnitsS2 = false;
	public int movingUnits = 0;
	public int specTileX, specTileY;
	public GameField field;
	public static final int turnP1 = Tile.factionPlayer1, turnP2 = Tile.factionPlayer2;
	public int turn = turnP1;
	public boolean showPending = false;
	public int showPendingUpdate = 0;
	public boolean gameEnded = false;
	public int winner = 0;
	
	public GUIGame(boolean p2IsAi){
		hasAI = p2IsAi;
		init();
	}
	
	public void init(){
		field = new GameField(8, 10);
		field.generate();
		if(hasAI)
		ai = new AI(this);
	}
	
	public void invokeButtonPress(int x, int y){
		if(!gameEnded){
			if(paused){
				if(x == 0 && y == 0){
					paused = false;
				}
				if(x == 0 && y == 2){
					Main.currentGUI = new GUIMainMenu();
				}
			}else if(!paused && !spectatingTile && !movingUnitsS1 && !movingUnitsS2){
				if(!field.tiles[x][y].isSea){
					specTileX = x;
					specTileY = y;
					spectatingTile = true;
				}
			}else if(spectatingTile){
				if(x == 0 && y == 0)
				spectatingTile = false;
				if(x == 1 && y == 0){
					field.tiles[specTileX][specTileY].pendingMode = Tile.modeInactive;
				}
				if(x == 1 && y == 1){
					field.tiles[specTileX][specTileY].pendingMode = Tile.modeScout;
				}
				if(x == 1 && y == 2){
					field.tiles[specTileX][specTileY].pendingMode = Tile.modeFortify;
				}
				if(x == 0 && y == 1 && !field.tiles[specTileX][specTileY].wasCaptured){
					spectatingTile = false;
					movingUnitsS1 = true;
					movingUnits = 0;
				}
			}else if(movingUnitsS1){
				if(x == 0 && y == 0){
					movingUnitsS1 = false;
					spectatingTile = true;
				}
				if(x == 0 && y == 1){
					movingUnitsS2 = true;
					movingUnitsS1 = false;
				}
				if(x == 2){
					if(y == 0 && field.tiles[specTileX][specTileY].troops >= 6)
					movingUnits = 6;
					if(y == 1 && field.tiles[specTileX][specTileY].troops >= 5)
					movingUnits = 5;
					if(y == 2 && field.tiles[specTileX][specTileY].troops >= 4)
					movingUnits = 4;
				}
				if(x == 3){
					if(y == 0 && field.tiles[specTileX][specTileY].troops >= 3)
					movingUnits = 3;
					if(y == 1 && field.tiles[specTileX][specTileY].troops >= 2)
					movingUnits = 2;
					if(y == 2 && field.tiles[specTileX][specTileY].troops >= 1)
					movingUnits = 1;
				}
			}else if(movingUnitsS2){
				moveUnits(specTileX, specTileY, Main.cursorGUI.x, Main.cursorGUI.y);
				movingUnitsS2 = false;
			}
		}
	}
	
	public void invokeKeyPress(KeyEvent e){
		if(!gameEnded){
			if(e.getKeyCode() == KeyEvent.VK_ESCAPE && !spectatingTile && !movingUnitsS1 && !movingUnitsS2){
				paused = !paused;
			}
			if(e.getKeyCode() == KeyEvent.VK_ESCAPE && spectatingTile){
				spectatingTile = false;
			}
			if(e.getKeyCode() == KeyEvent.VK_ESCAPE && (movingUnitsS1 || movingUnitsS2)){
				spectatingTile = true;
				movingUnitsS1 = false;
				movingUnitsS2 = false;
			}
			if(e.getKeyCode() == KeyEvent.VK_SPACE && !paused && !spectatingTile && !movingUnitsS1 && !movingUnitsS2){
				updateTurn();
			}
		}else{
			if(e.getKeyCode() == KeyEvent.VK_ESCAPE)
			Main.currentGUI = new GUIMainMenu();
		}
	}
	
	public void draw(Graphics g){
		if(!gameEnded){
			field.draw(g);
			if(paused || spectatingTile || movingUnitsS1){
				g.setColor(new Color(0, 0, 0, 192));
				g.fillRect(0, 0, Main.frame.getWidth(), Main.frame.getHeight());
			}
			if(paused){
				g.setColor(Color.GREEN);
				g.fillRect(0, 0, Main.pixelWidth, Main.pixelHeight);
				g.setColor(Color.RED);
				g.fillRect(0, 2 * Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
				g.setColor(GameField.colorPlayer1);
				g.fillRect(Main.pixelWidth, Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
				g.setColor(GameField.colorPlayer2);
				g.fillRect(2 * Main.pixelWidth, Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
				g.setColor(new Color(255, 255, 255, Main.cursorGUI.alphaTick));
				if(turn == 1)
				g.fillRect(Main.pixelWidth, Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
				else
				g.fillRect(2 * Main.pixelWidth, Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
			}
			if(spectatingTile){
				g.setColor(Color.RED);
				g.fillRect(0, 0, Main.pixelWidth, Main.pixelHeight);
				if(field.tiles[specTileX][specTileY].faction == turn){
					g.setColor(Color.WHITE);
					g.fillRect(Main.pixelWidth, 0, Main.pixelWidth, Main.pixelHeight);
					g.setColor(Color.BLUE);
					g.fillRect(Main.pixelWidth, Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
					g.setColor(Color.GRAY);
					g.fillRect(Main.pixelWidth, 2 * Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
					if(!field.tiles[specTileX][specTileY].wasCaptured){
						g.setColor(Color.MAGENTA);
						g.fillRect(0, Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
					}
					if(field.tiles[specTileX][specTileY].pendingMode == Tile.modeScout && showPending){
						g.setColor(Color.BLUE);
					}else if(field.tiles[specTileX][specTileY].pendingMode == Tile.modeFortify && showPending){
						g.setColor(Color.GRAY);
					}else if(field.tiles[specTileX][specTileY].pendingMode == Tile.modeInactive && showPending){
						g.setColor(Color.WHITE);
					}else if(field.tiles[specTileX][specTileY].mode == Tile.modeScout){
						g.setColor(Color.BLUE);
					}else if(field.tiles[specTileX][specTileY].mode == Tile.modeFortify){
						g.setColor(Color.GRAY);
					}else{
						g.setColor(Color.WHITE);
					}
					if(field.tiles[specTileX][specTileY].troops <= 3){
						g.fillRect(3 * Main.pixelWidth, 3 * Main.pixelHeight - Main.pixelHeight * field.tiles[specTileX][specTileY].troops, Main.pixelWidth, Main.pixelHeight * field.tiles[specTileX][specTileY].troops);
					}else if(field.tiles[specTileX][specTileY].troops > 3){
						g.fillRect(3 * Main.pixelWidth, 0, Main.pixelWidth, 3 * Main.pixelHeight);
						g.fillRect(2 * Main.pixelWidth, 3 * Main.pixelHeight - Main.pixelHeight * (field.tiles[specTileX][specTileY].troops - 3), Main.pixelWidth, Main.pixelHeight * (field.tiles[specTileX][specTileY].troops - 3));
					}
				}
			}
			if(movingUnitsS1){
				g.setColor(Color.RED);
				g.fillRect(0, 0, Main.pixelWidth, Main.pixelHeight);
				g.setColor(Color.GREEN);
				g.fillRect(0, Main.pixelHeight, Main.pixelWidth, Main.pixelHeight);
				g.setColor(Color.GRAY);
				if(field.tiles[specTileX][specTileY].troops <= 3){
					g.fillRect(3 * Main.pixelWidth, 3 * Main.pixelHeight - Main.pixelHeight * field.tiles[specTileX][specTileY].troops, Main.pixelWidth, Main.pixelHeight * field.tiles[specTileX][specTileY].troops);
				}else if(field.tiles[specTileX][specTileY].troops > 3){
					g.fillRect(3 * Main.pixelWidth, 0, Main.pixelWidth, 3 * Main.pixelHeight);
					g.fillRect(2 * Main.pixelWidth, 3 * Main.pixelHeight - Main.pixelHeight * (field.tiles[specTileX][specTileY].troops - 3), Main.pixelWidth, Main.pixelHeight * (field.tiles[specTileX][specTileY].troops - 3));
				}
				g.setColor(Color.WHITE);
				if(movingUnits <= 3){
					g.fillRect(3 * Main.pixelWidth, 3 * Main.pixelHeight - Main.pixelHeight * movingUnits, Main.pixelWidth, Main.pixelHeight * movingUnits);
				}else if(movingUnits > 3){
					g.fillRect(3 * Main.pixelWidth, 0, Main.pixelWidth, 3 * Main.pixelHeight);
					g.fillRect(2 * Main.pixelWidth, 3 * Main.pixelHeight - Main.pixelHeight * (movingUnits - 3), Main.pixelWidth, Main.pixelHeight * (movingUnits - 3));
				}
			}
		}else{
			field.draw(g);
			if(showPending){
				if(winner == turnP1)
				g.setColor(GameField.colorPlayer1);
				if(winner == turnP2)
				g.setColor(GameField.colorPlayer2);
				g.fillRect(0, 0, Main.frame.getWidth(), Main.frame.getHeight());
			}
		}
	}
	
	public void moveUnits(int fromX, int fromY, int toX, int toY){
		if(field.tiles[fromX][fromY].faction == turn && field.tiles[fromX][fromY].troops >= movingUnits && (Math.abs(fromX - toX) == 1 ^ Math.abs(fromY - toY) == 1)){
			if(field.tiles[fromX][fromY].faction == field.tiles[toX][toY].faction && field.tiles[fromX][fromY].troops + movingUnits <= 6){
				field.tiles[fromX][fromY].troops -= movingUnits;
				field.tiles[toX][toY].troops += movingUnits;
				if(field.tiles[toX][toY].troops > 6){
					field.tiles[fromX][fromY].troops += field.tiles[toX][toY].troops - 6;
					field.tiles[toX][toY].troops = 6;
				}
			}else if(field.tiles[fromX][fromY].faction != field.tiles[toX][toY].faction){
				int defendingUnits = field.tiles[toX][toY].troops;
				int attackerAtt = movingUnits;
				int targetDef = defendingUnits;
				if(field.tiles[fromX][fromY].mode == Tile.modeScout){
					attackerAtt *= 1.5;
					movingUnits *= 1.5;
				}
				if(field.tiles[toX][toY].mode == Tile.modeFortify){
					targetDef *= 2;
					defendingUnits *= 2;
				}
				field.tiles[fromX][fromY].troops -= movingUnits;
				movingUnits -= targetDef;
				field.tiles[toX][toY].troops -= attackerAtt;
				if(movingUnits < 0)
				movingUnits = 0;
				if(field.tiles[toX][toY].troops < 0)
				field.tiles[toX][toY].troops = 0;
				if(field.tiles[toX][toY].troops == 0 && movingUnits > 0){
					field.tiles[toX][toY].faction = turn;
					field.tiles[toX][toY].troops = movingUnits;
					field.tiles[toX][toY].wasCaptured = true;
					field.tiles[toX][toY].mode = Tile.modeInactive;
					field.tiles[toX][toY].pendingMode = Tile.modeInactive;
					checkWin();
				}
			}
		}
	}
	
	public void updateTurn(){
		if(turn == 1 && !hasAI){
			turn = 2;
		}else if(turn == 1 && hasAI){
			turn = 2;
			ai.processTurn();
			turn = 1;
		}else if(turn == 2){
			turn = 1;
		}
		for(int x = 0;x < 4;x++){
			for(int y = 0;y < 3;y++){
				if(field.tiles[x][y].faction != Tile.factionNeutral){
					field.tiles[x][y].updateTurn();
				}
			}
		}
	}
	
	public void checkWin(){
		boolean p1Exists = false;
		boolean p2Exists = false;
		for(int x = 0;x < 4;x++){
			for(int y = 0;y < 3;y++){
				if(field.tiles[x][y].faction == turnP1){
					p1Exists = true;
				}
				if(field.tiles[x][y].faction == turnP2){
					p2Exists = true;
				}
			}
			if(p1Exists && p2Exists){
				break;
			}
		}
		if(p1Exists && !p2Exists){
			gameEnded = true;
			winner = turnP1;
		}else if(!p1Exists && p2Exists){
			gameEnded = true;
			winner = turnP2;
		}
	}
	
	public void tick(){
		showPendingUpdate++;
		if(showPendingUpdate >= 20){
			showPending = !showPending;
			showPendingUpdate = 0;
		}
	}
}
