package brentmaas.CW4x3Challenge;
import java.awt.*;
import java.util.*;

public class GameField {
	public Tile[][] tiles;
	public PixelField field;
	
	public int min, max, totalTiles;
	
	public static final Color colorPlayer1 = Color.RED;
	public static final Color colorPlayer2 = Color.YELLOW;
	
	public GameField(int minTiles, int maxTiles){
		min = minTiles;
		max = maxTiles;
	}
	
	public void draw(Graphics g){
		field.draw(g);
		for(int x = 0;x < 4;x++){
			for(int y = 0;y < 3;y++){
				if(tiles[x][y].faction == Tile.factionPlayer1){
					g.setColor(colorPlayer1);
					g.fillRect(Main.pixelWidth * x, Main.pixelHeight * y, Main.pixelWidth, Main.pixelHeight);
				}else if(tiles[x][y].faction == Tile.factionPlayer2){
					g.setColor(colorPlayer2);
					g.fillRect(Main.pixelWidth * x, Main.pixelHeight * y, Main.pixelWidth, Main.pixelHeight);
				}
			}
		}
	}
	
	public void tick(){
		field = new PixelField(800, 600);
		for(int x = 0;x < 4;x++){
			for(int y = 0;y < 3;y++){
				if(!tiles[x][y].isSea){
					field.pixels[x][y] = new Pixel(0, 255, 0);
				}else if(tiles[x][y].isSea){
					field.pixels[x][y] = new Pixel(0, 0, 255);
				}else{
					field.pixels[x][y] = new Pixel(0, 0, 0);
				}
			}
		}
	}
	
	public void generate(){
		tiles = new Tile[4][3];
		totalTiles = new Random().nextInt(max - min) + min;
		int startX = new Random().nextInt(2) + 1;
		int startY = new Random().nextInt(1) + 1;
		tiles[startX][startY] = new Tile(false);
		tiles[startX + 1][startY] = new Tile(false);
		tiles[startX - 1][startY] = new Tile(false);
		tiles[startX][startY + 1] = new Tile(false);
		tiles[startX][startY - 1] = new Tile(false);
		int tilesGenerated = 5;
		while(tilesGenerated < totalTiles){
			for(int x = 0;x < 4;x++){
				for(int y = 0;y < 3;y++){
					try{
						if(tiles[x][y] == null && tiles[x - 1][y] != null && !tiles[x - 1][y].isSea && new Random().nextInt(20) <= 5){
							tiles[x][y] = new Tile(false);
							tilesGenerated++;
						}else if(tiles[x][y] == null && tiles[x + 1][y] != null && !tiles[x + 1][y].isSea && new Random().nextInt(20) <= 5){
							tiles[x][y] = new Tile(false);
							tilesGenerated++;
						}else if(tiles[x][y] == null && tiles[x][y - 1] != null && !tiles[x][y - 1].isSea && new Random().nextInt(20) <= 5){
							tiles[x][y] = new Tile(false);
							tilesGenerated++;
						}else if(tiles[x][y] == null && tiles[x][y + 1] != null && !tiles[x][y + 1].isSea && new Random().nextInt(20) <= 5){
							tiles[x][y] = new Tile(false);
							tilesGenerated++;
						}
					}catch(ArrayIndexOutOfBoundsException | NullPointerException e){}
				}
			}
		}
		for(int x = 0;x < 4;x++){
			for(int y = 0;y < 3;y++){
				if(tiles[x][y] == null){
					tiles[x][y] = new Tile(true);
				}
			}
		}
		
		boolean designated = false;
		int x1 = -1, x2 = -1, y1 = -1, y2 = -1;
		while(!designated){
			x1 = new Random().nextInt(3);
			x2 = new Random().nextInt(3);
			y1 = new Random().nextInt(2);
			y2 = new Random().nextInt(2);
			if((x1 != x2 || y1 != y2) && !tiles[x1][y1].isSea && !tiles[x2][y2].isSea)
			designated = true;
		}
		if(x1 != -1 && x2 != -1 && y1 != -1 && y2 != -1){
			tiles[x1][y1].faction = Tile.factionPlayer1;
			tiles[x1][y1].troops = 3;
			tiles[x2][y2].faction = Tile.factionPlayer2;
			tiles[x2][y2].troops = 3;
		}else{
			System.out.println("Generation error, shutting down");
			System.exit(-1);
		}
		
		tick();
	}
}
